//*****************************************************************************
//*****************************************************************************
//  FILENAME:   Table_TC_T.h
//  Version: 1.0, 2008/01/16 
//  Generated by Peter Lischer
//
//  DESCRIPTION:  Table for Thermocouple Type T
//
//-----------------------------------------------------------------------------
// Originally authored by Toradex AG. This work is now available under the terms and conditions
// of the Creative Commons License 'Attribution CC BY', details of which can be found here:
// http://creativecommons.org/licenses/by/3.0/
//*****************************************************************************
//*****************************************************************************


/*
	Sensor used from	-200C
	until				370C
	
	Table valid from	-200.75C
	until				400C

	Table entries from	-205.55C
	until				400.75C

	Reference Voltage	4.096V
	R1					1k2
	R2					27k
*/

#define TC_TYPE_T				2
#define TC_TYPE_T_ASCII			'T'

#define ADC2TMP_MIN_T	 		-2368
#define ADC2TMP_MID_T 			0
#define ADC2TMP_MAX_T 			8704

#define ADC2TMP_LO_LENGTH_T 	38
#define ADC2TMP_HI_LENGTH_T 	35


#define REF2ADC_MIN_T		 	-1536		//Not used, is constant over all Couple Types
#define REF2ADC_MAX_T		 	11264		//Not used, is constant over all Couple Types

#define REF2ADC_LENGTH_T		26			//Not used, is constant over all Couple Types

const unsigned int ADC2TmpLo_T[ADC2TMP_LO_LENGTH_T] =	
{
	676,
	773,
	864,
	949,
	1029,
	1105,
	1178,
	1247,
	1314,
	1379,
	1442,
	1502,
	1561,
	1619,
	1675,
	1730,
	1784,
	1836,
	1888,
	1938,
	1988,
	2036,
	2084,
	2132,
	2178,
	2224,
	2269,
	2314,
	2358,
	2401,
	2444,
	2486,
	2528,
	2570,
	2611,
	2651,
	2692,
	2732,
};

const unsigned int ADC2TmpHi_T[ADC2TMP_HI_LENGTH_T] =	
{
	2732,
	2888,
	3040,
	3187,
	3330,
	3469,
	3605,
	3738,
	3868,
	3996,
	4121,
	4245,
	4366,
	4486,
	4604,
	4721,
	4836,
	4950,
	5062,
	5174,
	5284,
	5393,
	5502,
	5609,
	5716,
	5821,
	5926,
	6030,
	6133,
	6236,
	6338,
	6439,
	6540,
	6640,
	6739,
};

const int Ref2ADC_T[REF2ADC_LENGTH_T] =	
{
	-191,
	-128,
	-64,
	0,
	65,
	130,
	196,
	262,
	328,
	396,
	464,
	532,
	601,
	671,
	741,
	811,
	883,
	954,
	1027,
	1100,
	1173,
	1247,
	1322,
	1397,
	1472,
	1549,
};