	cpu LMM
	.module digitalio.c
	.area text(rom, con, rel)
	.dbfile ./digitalio.c
	.dbfunc e DigitalIO_Start _DigitalIO_Start fV
_DigitalIO_Start::
	.dbline -1
	.dbline 45
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:   DigitalIO.c
; //  Version: 1.0, 2006/10/25 
; //  Generated by Andy Kiser
; //
; //  DESCRIPTION:  Processing digital inputs/outputs controlled by USB
; //
; //-----------------------------------------------------------------------------
; // Originally authored by Toradex AG. This work is now available under the terms and conditions
; // of the Creative Commons License 'Attribution CC BY', details of which can be found here:
; // http://creativecommons.org/licenses/by/3.0/
; //*****************************************************************************
; //*****************************************************************************
; #include <m8c.h>        // part specific constants and macros
; #include "feature.h"
; #include "parameters.h"
; #include "types_n_macros.h"
; 
; // define registers according to the port definitions above
; #define PRT_IN_DM2	PRT5DM2
; #define PRT_IN_DM1	PRT5DM1
; #define PRT_IN_DM0	PRT5DM0
; #define PRT_IN_DR	PRT5DR
; 
; #define PRT_OUT_DM2	PRT4DM2
; #define PRT_OUT_DM1	PRT4DM1
; #define PRT_OUT_DM0	PRT4DM0
; #define PRT_OUT_DR	PRT4DR
; 
; #define PRT_LED_DM2	PRT0DM2
; #define PRT_LED_DM1	PRT0DM1
; #define PRT_LED_DM0	PRT0DM0
; #define PRT_LED_DR	PRT0DR
; 
; #define MASK_LED	0x02	// %0000'0010  -> LED connected to PORT0[1]
; 
; // state variables
; static BYTE DigOut_Shadow;
; 
; //-----------------------------------------------------------------------------
; // Initialize Digital Input / Output pins
; //-----------------------------------------------------------------------------
; void DigitalIO_Start()
; {
	.dbline 47
; 	// -- initialize "ShowUp" LED
; 	GPIO_DM_OPENDRAIN(LED_SHOWUP)
	or REG[0x3],2
	.dbline 47
	or F,0x10  ; iopage = 1
	or REG[0x1],2
	.dbline 47
	or F,0x10  ; iopage = 1
	or REG[ 0],2
	and F,0xEF ; iopage = 0
	.dbline 48
; 	GPIO_HIGH(LED_SHOWUP)
	or REG[ 0],2
	.dbline 52
; 	
; 	// -- initialize Digital Outputs
; 	// Set Port4 Drivemode to [001b] (Strong Digital Output)
; 	PRT_OUT_DM2 = 0x00;	// set driver mode and strength
	mov REG[0x13],0
	.dbline 53
; 	PRT_OUT_DM1 = 0x00;
	or F,0x10  ; iopage = 1
	mov REG[0x11],0
	.dbline 54
; 	PRT_OUT_DM0 = 0xFF;
	or F,0x10  ; iopage = 1
	mov REG[0x10],-1
	and F,0xEF ; iopage = 0
	.dbline 56
; 	
; 	DigOut_Shadow = 0x00;
	mov REG[0xd0],>_DigOut_Shadow
	mov [_DigOut_Shadow],0
	.dbline 57
; 	PRT_OUT_DR  = DigOut_Shadow;	// set all 8 outputs to 0
	mov A,[_DigOut_Shadow]
	mov REG[0x10],A
	.dbline 61
; 
; 	// -- initialize Digital Inputs
; 	// Set Port5 Drivemode to [010b] (Digital Input)
; 	PRT_IN_DM2 = 0x00;	// set driver mode and strength
	mov REG[0x17],0
	.dbline 62
; 	PRT_IN_DM1 = 0xFF;
	or F,0x10  ; iopage = 1
	mov REG[0x15],-1
	.dbline 63
; 	PRT_IN_DM0 = 0x00;
	or F,0x10  ; iopage = 1
	mov REG[0x14],0
	and F,0xEF ; iopage = 0
	.dbline -2
	.dbline 64
; }
L6:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DigitalIO_Suspend _DigitalIO_Suspend fV
_DigitalIO_Suspend::
	.dbline -1
	.dbline 70
; 
; //-----------------------------------------------------------------------------
; // Prepare for Suspend
; //-----------------------------------------------------------------------------
; void DigitalIO_Suspend()
; {
	.dbline 73
; 	// -- Set all Drivemodes to [110b] (HiZ, digital in disabled for zero power)
; 	// particular use (e.g. "smile" LED)
; 	GPIO_DM_HIGHZ(LED_SHOWUP)
	and REG[0x3],-3
	.dbline 73
	or F,0x10  ; iopage = 1
	or REG[0x1],2
	.dbline 73
	or F,0x10  ; iopage = 1
	and REG[ 0],-3
	and F,0xEF ; iopage = 0
	.dbline 76
; 	
; 	// initialize Digital Outputs
; 	PRT_OUT_DM2 = 0xFF;	// set driver mode and strength
	mov REG[0x13],-1
	.dbline 77
; 	PRT_OUT_DM1 = 0xFF;
	or F,0x10  ; iopage = 1
	mov REG[0x11],-1
	.dbline 78
; 	PRT_OUT_DM0 = 0x00;
	or F,0x10  ; iopage = 1
	mov REG[0x10],0
	and F,0xEF ; iopage = 0
	.dbline 81
; 	
; 	// initialize Digital Inputs
; 	PRT_IN_DM2 = 0xFF;	// set driver mode and strength
	mov REG[0x17],-1
	.dbline 82
; 	PRT_IN_DM1 = 0xFF;
	or F,0x10  ; iopage = 1
	mov REG[0x15],-1
	.dbline 83
; 	PRT_IN_DM0 = 0x00;
	or F,0x10  ; iopage = 1
	mov REG[0x14],0
	and F,0xEF ; iopage = 0
	.dbline -2
	.dbline 84
; }
L7:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DigitalIO_Resume _DigitalIO_Resume fV
_DigitalIO_Resume::
	.dbline -1
	.dbline 90
; 
; //-----------------------------------------------------------------------------
; // Resume from Suspend 
; //-----------------------------------------------------------------------------
; void DigitalIO_Resume()
; {
	.dbline 94
; 	// -- restore drive modes
; 	
; 	// -- initialize "ShowUp" LED
; 	GPIO_DM_OPENDRAIN(LED_SHOWUP)
	or REG[0x3],2
	.dbline 94
	or F,0x10  ; iopage = 1
	or REG[0x1],2
	.dbline 94
	or F,0x10  ; iopage = 1
	or REG[ 0],2
	and F,0xEF ; iopage = 0
	.dbline 95
; 	GPIO_HIGH(LED_SHOWUP)
	or REG[ 0],2
	.dbline 96
; 	GPIO_HIGH(nOFF_ON)		//Hack Peter due to problems with reading of the nOFF_ON register (reads a 0)
	or REG[ 0],1
	.dbline 100
; 	
; 	// -- initialize Digital Outputs
; 	// Set Port4 Drivemode to [001b] (Strong Digital Output)
; 	PRT_OUT_DM2 = 0x00;	// set driver mode and strength
	mov REG[0x13],0
	.dbline 101
; 	PRT_OUT_DM1 = 0x00;
	or F,0x10  ; iopage = 1
	mov REG[0x11],0
	.dbline 102
; 	PRT_OUT_DM0 = 0xFF;
	or F,0x10  ; iopage = 1
	mov REG[0x10],-1
	and F,0xEF ; iopage = 0
	.dbline 106
; 
; 	// -- initialize Digital Inputs
; 	// Set Port2 Drivemode to [010b] (Digital Input)
; 	PRT_IN_DM2 = 0x00;	// set driver mode and strength
	mov REG[0x17],0
	.dbline 107
; 	PRT_IN_DM1 = 0xFF;
	or F,0x10  ; iopage = 1
	mov REG[0x15],-1
	.dbline 108
; 	PRT_IN_DM0 = 0x00;
	or F,0x10  ; iopage = 1
	mov REG[0x14],0
	and F,0xEF ; iopage = 0
	.dbline -2
	.dbline 109
; }
L8:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile ./digitalio.c
L10:
	.word 0
	.area text(rom, con, rel)
	.dbfile ./digitalio.c
	.dbfunc e FSM_LEDmode _FSM_LEDmode fV
	.dbsym s Count_ms L10 i
;      LedStatus -> X+0
_FSM_LEDmode::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 116
; 
; //-----------------------------------------------------------------------------
; // ShowUp state machine
; // call this function once every millisecond
; //-----------------------------------------------------------------------------
; void FSM_LEDmode ()
; {
	.dbline 121
; 	static WORD Count_ms = 0;
; 	BYTE		LedStatus;
; 
; 	#define PAR8_LEDMODE 1
; 	Get_Param_8(PAR8_LEDMODE, VOLATILE, &LedStatus);
	mov REG[0xd0],>__r0
	mov A,3
	push A
	push X
	mov A,0
	push A
	mov A,1
	push A
	xcall _Get_Param_8
	add SP,-4
	.dbline 123
; 	
; 	switch (LedStatus)
	mov A,[X+0]
	mov [X+2],A
	mov [X+1],0
	cmp [X+1],0
	jnz X2
	cmp [X+2],0
	jz L14
X2:
	cmp [X+1],0
	jnz X3
	cmp [X+2],1
	jz L15
X3:
	cmp [X+1],0
	jnz X4
	cmp [X+2],2
	jz L16
X4:
	cmp [X+1],0
	jnz X5
	cmp [X+2],3
	jz L21
X5:
	cmp [X+1],0
	jnz X6
	cmp [X+2],4
	jz L26
X6:
	xjmp L11
X0:
	.dbline 124
; 	{
L14:
	.dbline 127
; 	// ---- LED OFF
; 	case 0:
; 		GPIO_HIGH(LED_SHOWUP) // LED off
	or REG[ 0],2
	.dbline 128
; 		break;
	xjmp L12
L15:
	.dbline 132
; 		
; 	// ---- LED ON
; 	case 1:
; 		GPIO_LOW(LED_SHOWUP) // LED on
	and REG[ 0],-3
	.dbline 133
; 		break;
	xjmp L12
L16:
	.dbline 137
; 		
; 	// ---- LED blink slow
; 	case 2:
; 		if (Count_ms == 0)
	mov REG[0xd0],>L10
	cmp [L10],0
	jnz L17
	cmp [L10+1],0
	jnz L17
X7:
	.dbline 138
; 		{
	.dbline 139
; 			GPIO_LOW(LED_SHOWUP) // LED on
	and REG[ 0],-3
	.dbline 140
; 			Count_ms = 500;
	mov REG[0xd0],>L10
	mov [L10+1],-12
	mov [L10],1
	.dbline 141
; 		}
	xjmp L12
L17:
	.dbline 142
; 		else if (Count_ms == 450)
	mov REG[0xd0],>L10
	cmp [L10],1
	jnz L12
	cmp [L10+1],-62
	jnz L12
X8:
	.dbline 143
; 			GPIO_HIGH(LED_SHOWUP) // LED off
	or REG[ 0],2
	.dbline 144
; 		break;
	xjmp L12
L21:
	.dbline 148
; 	// ---- LED blink fast
; 
; 	case 3:
; 		if (Count_ms == 0)
	mov REG[0xd0],>L10
	cmp [L10],0
	jnz L22
	cmp [L10+1],0
	jnz L22
X9:
	.dbline 149
; 		{
	.dbline 150
; 			GPIO_LOW(LED_SHOWUP) // LED on
	and REG[ 0],-3
	.dbline 151
; 			Count_ms = 150;
	mov REG[0xd0],>L10
	mov [L10+1],-106
	mov [L10],0
	.dbline 152
; 		}
	xjmp L23
L22:
	.dbline 153
; 		else if (Count_ms == 100)
	mov REG[0xd0],>L10
	cmp [L10],0
	jnz L24
	cmp [L10+1],100
	jnz L24
X10:
	.dbline 154
; 			GPIO_HIGH(LED_SHOWUP) // LED off
	or REG[ 0],2
L24:
	.dbline 155
; 		else;
L25:
L23:
L26:
	.dbline 159
; 	
; 	// ---- LED blink quad
; 	case 4:
; 		switch (Count_ms)
	mov REG[0xd0],>L10
	mov A,[L10+1]
	sub A,64
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov REG[0xd0],>L10
	mov A,[L10]
	xor A,-128
	sbb A,(6 ^ 0x80)
	mov REG[0xd0],>__r0
	or A,[__rY]
	jz L29
	jnc L33
X11:
L32:
	mov REG[0xd0],>L10
	mov A,[L10+1]
	sub A,70
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov REG[0xd0],>L10
	mov A,[L10]
	xor A,-128
	sbb A,(5 ^ 0x80)
	mov REG[0xd0],>__r0
	or A,[__rY]
	jz L30
	jnc L35
X12:
L34:
	mov REG[0xd0],>L10
	cmp [L10],0
	jnz X13
	cmp [L10+1],0
	jz L31
X13:
	xjmp L27
L35:
	mov REG[0xd0],>L10
	mov A,[L10+1]
	sub A,120
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov REG[0xd0],>L10
	mov A,[L10]
	xor A,-128
	sbb A,(5 ^ 0x80)
	jc L27
	mov REG[0xd0],>__r0
	or A,[__rY]
	jz L29
X14:
L36:
	mov REG[0xd0],>L10
	cmp [L10],6
	jnz X15
	cmp [L10+1],14
	jz L30
X15:
	xjmp L27
L33:
	mov REG[0xd0],>L10
	mov A,[L10+1]
	sub A,8
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov REG[0xd0],>L10
	mov A,[L10]
	xor A,-128
	sbb A,(7 ^ 0x80)
	mov REG[0xd0],>__r0
	or A,[__rY]
	jz L29
	jnc L38
X16:
L37:
	mov REG[0xd0],>L10
	cmp [L10],6
	jnz X17
	cmp [L10+1],-42
	jz L30
X17:
	xjmp L27
L38:
	mov REG[0xd0],>L10
	mov A,[L10+1]
	sub A,-98
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov REG[0xd0],>L10
	mov A,[L10]
	xor A,-128
	sbb A,(7 ^ 0x80)
	jc L27
	mov REG[0xd0],>__r0
	or A,[__rY]
	jz L30
X18:
L39:
	mov REG[0xd0],>L10
	cmp [L10],7
	jnz X19
	cmp [L10+1],-48
	jz L29
X19:
	xjmp L27
X1:
	.dbline 160
; 		{
L29:
	.dbline 165
; 		case 2000:
; 		case 1800:
; 		case 1600:
; 		case 1400:
; 				GPIO_LOW(LED_SHOWUP) // LED on
	and REG[ 0],-3
	.dbline 166
; 				break;
	xjmp L28
L30:
	.dbline 172
; 
; 		case 1950:
; 		case 1750:
; 		case 1550:
; 		case 1350:
; 				GPIO_HIGH(LED_SHOWUP) // LED off
	or REG[ 0],2
	.dbline 173
; 				break;
	xjmp L28
L31:
	.dbline 176
; 				
; 		case 0:
; 				Count_ms = 2001;
	mov REG[0xd0],>L10
	mov [L10+1],-47
	mov [L10],7
	.dbline 178
; 		
; 		}
L27:
L28:
	.dbline 179
; 	}
L11:
L12:
	.dbline 180
	mov REG[0xd0],>L10
	cmp [L10],0
	jnz X20
	cmp [L10+1],0
	jz L40
X20:
	.dbline 181
	mov REG[0xd0],>L10
	dec [L10+1]
	sbb [L10],0
L40:
	.dbline -2
	.dbline 182
; 	if (Count_ms != 0)
; 		Count_ms--;
; }
L9:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l LedStatus 0 c
	.dbend
	.dbfunc e DigitalOut_Set _DigitalOut_Set fV
;        msk_xor -> X-6
;         msk_or -> X-5
;        msk_and -> X-4
_DigitalOut_Set::
	.dbline -1
	push X
	mov X,SP
	.dbline 188
; 
; //-----------------------------------------------------------------------------
; // Function to set the value of the 8 digital outputs
; //-----------------------------------------------------------------------------
; void DigitalOut_Set (BYTE msk_and, BYTE msk_or, BYTE msk_xor)
; {
	.dbline 189
; 	DigOut_Shadow = ( (DigOut_Shadow & msk_and) | msk_or ) ^ msk_xor;
	mov REG[0xd0],>_DigOut_Shadow
	mov A,[_DigOut_Shadow]
	and A,[X-4]
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov A,[X-5]
	or [__r0],A
	mov A,[X-6]
	xor [__r0],A
	mov A,[__r0]
	mov REG[0xd0],>_DigOut_Shadow
	mov [_DigOut_Shadow],A
	.dbline 190
; 	PRT_OUT_DR = DigOut_Shadow;
	mov A,[_DigOut_Shadow]
	mov REG[0x10],A
	.dbline -2
	.dbline 191
; }
L42:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l msk_xor -6 c
	.dbsym l msk_or -5 c
	.dbsym l msk_and -4 c
	.dbend
	.dbfunc e DigitalIn_Get _DigitalIn_Get fc
_DigitalIn_Get::
	.dbline -1
	.dbline 198
; 
; 
; //-----------------------------------------------------------------------------
; // Function returns value of the 8 digital inputs
; //-----------------------------------------------------------------------------
; BYTE DigitalIn_Get (void)
; {
	.dbline 199
; 	return PRT_IN_DR;
	mov A,REG[0x14]
	mov REG[0xd0],>__r0
	.dbline -2
L43:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile ./digitalio.c
_DigOut_Shadow:
	.byte 0
	.dbsym s DigOut_Shadow _DigOut_Shadow c
